<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
  LogConfig.jsp

  Copyright 2005 Chris Schultz - www.christopherschultz.net

  Allows you to change the configuration for Loggers defined
  using the log4j package.

  Please see the Creative Commons license at the end of this file
  for licensing information. The plain-English version of the license
  is "do whatever you want with this, just give me some credit".

  Enjoy!
-->
<%@page
    language="java"
    session="false"
    isErrorPage="false"
    import="
	java.util.ArrayList,
	java.util.Collection,
	java.util.Collections,
	java.util.Enumeration,
	java.util.Iterator,
	java.util.HashSet,
	java.util.HashMap,
	java.util.Map,
	org.apache.log4j.Appender,
	org.apache.log4j.LogManager,
	org.apache.log4j.Logger,
	org.apache.log4j.Level
    "
%>
<%@ include file="htmlescape.jsp" %>
<%!
    Level[] levels = { Level.toLevel("OFF"),
		       Level.toLevel("FATAL"),
		       Level.toLevel("ERROR"),
		       Level.toLevel("WARN"),
		       Level.toLevel("INFO"),
		       Level.toLevel("DEBUG"),
		       Level.toLevel("ALL") };

    Collection getAllAppenders(Logger logger)
    {
	HashSet s = new HashSet();

	// Get all the appenders for THIS logger
	for(Enumeration e = logger.getAllAppenders(); e.hasMoreElements(); )
	    s.add(e.nextElement());

	if(logger.getAdditivity())
	{
	    Logger parent = (Logger)logger.getParent();

	    while(null != parent)
	    {
		for(Enumeration e = parent.getAllAppenders(); e.hasMoreElements(); )
		    s.add(e.nextElement());

		parent = (Logger)parent.getParent();
	    }
	}

	return(s);
    }
%>
<%
    String loggerName = request.getParameter("logger");
    if(null == loggerName || "".equals(loggerName.trim()))
	loggerName = "[root]";
    if("root".equals(loggerName))
	loggerName = "[root]";
    String loggerLabel = htmlescape(loggerName);

    String message = request.getParameter("message");
    if(null == message)
	message = "";

    Logger logger;
    if("[root]".equals(loggerName))
	logger = Logger.getRootLogger();
    else
	logger = LogManager.exists(loggerName);

    String op = request.getParameter("op");
    if("test".equals(op)
	&& (null != logger))
    {
	logger.log(Level.toLevel(request.getParameter("level")),
		     request.getParameter("message"));
    }
    else if("modify_logger".equals(op))
    {
	logger.setLevel(Level.toLevel(request.getParameter("level")));
	logger.setAdditivity("true".equals(request.getParameter("additivity")));
    }
%>
<!--
<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:title>LogConfig.jsp</dc:title>
   <dc:date>2005</dc:date>
   <dc:description>A server&#45;side JSP which allows users to modify log4j loggers while the server is running.
</dc:description>
   <dc:creator><Agent>
      <dc:title>Christopher Schultz</dc:title>
   </Agent></dc:creator>
   <dc:rights><Agent>
      <dc:title>Christopher Schultz</dc:title>
   </Agent></dc:rights>
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Interactive" />
   <license rdf:resource="http://creativecommons.org/licenses/by-sa/2.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by-sa/2.0/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
   <requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
</License>

</rdf:RDF>
-->
<html lang="en">
<head>
    <title>Log Configurator</title>
    <style type="text/css"><!--
	body { font-family:sans-serif; }
	h1 { text-align:center; font-size:x-large; }
	h2 { font-size:large; }
	fieldset { background-color:#e0e0e0; padding-top:1em; margin-bottom:1em; }
	fieldset legend { font-size:medium; font-weight:bold; border:2px groove ThreeDFace; background-color:#e0e0e0; padding:0.4ex 1ex 0.4ex 1ex; }
	label[for] { cursor:pointer; }
	span.accelerator { text-decoration:underline; }
	label { float:left; width:5em; margin-right:1em; }
	.separator { clear:both; }
	ul#appenders { margin-top:0em; list-style-position:inside; }
	.logger-name { font-family:monospace; }
	.no-such-logger { font-family:monospace; color:red; }
    --></style>
</head>
<body>
<h1>Log Configurator</h1>

<div id="log-finder">
    <fieldset>
	<legend>Logger Search</legend>

<%
	if("list_loggers".equals(op))
	{
	    ArrayList allLoggers = new ArrayList();
	    for(Enumeration e = LogManager.getCurrentLoggers(); e.hasMoreElements(); )
		allLoggers.add(htmlescape(((Logger)e.nextElement()).getName()));

	    Collections.sort(allLoggers);
%>
	<ul id="loggers">
	    <li><a id="logger_root" href="<%= response.encodeURL(request.getRequestURI()) %>?logger=[root]">[root]</a></li>
<%
	    
	    for(Iterator i=allLoggers.iterator(); i.hasNext(); )
	    {
		String l = (String)i.next();
%>	    <li><a id="logger_<%= l %>" href="<%= response.encodeURL(request.getRequestURI()) %>?logger=<%= l %>"><%= l %></a></li>
<%
	    }
%>
	</ul>
	<p>
	    <a id="search_loggers" href="<%= response.encodeURL(request.getRequestURI()) %>">Search Loggers</a>
	</p>
<%
	}
	else
	{
%>
	<form method="get" action="<%= response.encodeURL(request.getRequestURI()) %>">
	<p>
	    <label for="logger" accesskey="n" style="width:6em;">Logger <span class="accelerator">N</span>ame</label>
	    <input id="logger" type="text" name="logger" size="50" value="<%= loggerLabel %>" />
	    <a id="list_loggers" href="<%= response.encodeURL(request.getRequestURI()) %>?op=list_loggers" title="List all the loggers in the system.">List Loggers</a>
	    <br class="separator" />
	    <input type="submit" value="View" accesskey="w" />
	</p>
	</form>
<%
	} // else(list_loggers)
%>
    </fieldset>
</div>

<div id="logger-info">
    <fieldset>
	<legend>Logger Info</legend>
<%
    if(null == logger)
    {
	// Did the user actually try to find a logger?
	if(!(null == loggerName || "".equals(loggerName.trim())))
	{
%>
	<p>
	    No Such Logger
	    <span class="no-such-logger"><%= loggerLabel %></span>.
	</p>
<%
	}
    }
    else
    {
%>
	<form method="get" action="<%= response.encodeURL(request.getRequestURI()) %>">
	<p>
	    <label>Logger</label>
	    <span class="logger-name"><%= loggerLabel %></span>.
	    <br class="separator" />

	    <label>Parent</label>
	    <span class="logger-name"><% if(null == logger.getParent()) { %>none<% } else { String parentName = htmlescape(logger.getParent().getName()); %><span class="logger-name"><a href="<%= response.encodeURL(request.getRequestURI()) %>?logger=<%= parentName %>"><%= parentName %></a><% } %></span>
	</p>

	<div id="settings">
	    <input type="hidden" name="op" value="modify_logger" />
	    <input type="hidden" name="logger" value="<%= loggerLabel %>" />
	    <label for="additivity" accesskey="a"><span class="accelerator">A</span>dditivity</label>
	<input id="additivity" type="checkbox" name="additivity" value="true" <% if(logger.getAdditivity()) { %>checked="checked"<% } %> />
	<br class="separator" />

	<label for="levelSelect" accesskey="l">Log
	<span class="accelerator">L</span>evel</label>

	<select id="levelSelect" name="level">
<%
	Level currentLevel = logger.getEffectiveLevel();

	for(int i=0; i<levels.length; ++i)
	{
	    Level level = levels[i];
	    String levelLabel = htmlescape(level.toString());
%>
	<option value="<%= levelLabel %>"<% if(currentLevel.equals(level)) { %> selected="selected"<% } %>><%= levelLabel %></option>
<%
	}
%>
	</select>
	<br class="separator" />

	<label>Appenders</label>

	<ul id="appenders">
<%
	for(Iterator i=this.getAllAppenders(logger).iterator(); i.hasNext(); )
	{
	    Appender appender = (Appender)i.next();
%>
	    <li><a id="appender_<%= htmlescape(appender.getName()) %>" href="<%= response.encodeURL("AppenderConfig.jsp?op=show_appender&amp;logger=" + loggerName + "&amp;appender=" + appender.getName()) %>" title="Edit this appender"><%= htmlescape(appender.getName()) %></a></li>
<%
	}
%>
	</ul>

	<input type="submit" value="Change" />
	</div>
    </form>
    </fieldset>
</div>

<div id="test">
    <fieldset>
	<legend>Logger Test</legend>

        <form method="get" action="<%= response.encodeURL(request.getRequestURI()) %>">
	<div id="test-controls">
	    <input type="hidden" name="op" value="test" />
	    <input type="hidden" name="logger" value="<%= loggerLabel %>" />

	    <label for="message" accesskey="m"><span class="accelerator">M</span>essage</label>
	    <input id="message" type="text" name="message" value="<%= htmlescape(message) %>" />
	    <br class="separator" />

	    <label for="testLevelSelect" accesskey="v">Le<span class="accelerator">v</span>el</label>
	    <select id="testLevelSelect" name="level">
<%
	for(int i=0; i<levels.length; ++i)
	{
	    Level level = levels[i];
	    String levelLabel = htmlescape(level.toString());

%>		<option value="<%= levelLabel %>"<% if(currentLevel.equals(level)) { %> selected="selected"<% } %>><%= levelLabel %></option>
<%
	}
%>
	    </select>
	    <br class="separator" />

	    <input type="submit" value="Test" />
	</div>
        </form>
<%
    } // if(null != logger)
%>
    </fieldset>
</div>

<hr />

<p class="license">
    <!-- Creative Commons License -->
    <a id="cc_license" rel="license" href="http://creativecommons.org/licenses/by-sa/2.0/">
    <img alt="Creative Commons License" style="border:none;"
        src="http://creativecommons.org/images/public/somerights20.gif" />
    </a>
    <!-- /Creative Commons License -->

    <a id="w3c_valid_xhtml" href="http://validator.w3.org/check?uri=referer"><img
          src="http://www.w3.org/Icons/valid-xhtml10"
          alt="Valid XHTML 1.0!" style="border:none;height:31px;width:88px;" />
    </a>

    <a id="w3c_valid_css" href="http://jigsaw.w3.org/css-validator/">
    <img style="border:0;width:88px;height:31px"
       src="http://jigsaw.w3.org/css-validator/images/vcss" 
       alt="Valid CSS!" />
    </a>
</p>
<p class="license">
    <!-- Creative Commons License -->
    This work is licensed under a <a id="cc_license_2" rel="license" href="http://creativecommons.org/licenses/by-sa/2.0/">Creative Commons License</a>.
    <!-- /Creative Commons License -->
</p>
</body>
</html>
